<app-header
    title="Diagnostics"
    subTitle="Conseils"
    [border]="false"
></app-header>
<ion-content [ngSwitch]="selectedTab">
    <!-- segments -->
    <div class="mx-10 border-top-1 border-0 border-solid has-border-gray pt-15">
        <ion-segment [(ngModel)]="selectedTab" class="radius-0">
            <ion-segment-button
                class="diagnostic__tab"
                [value]="diagnosticTabs.diagnostic"
            >
                <ion-label>Diagnostics</ion-label>
            </ion-segment-button>
            <ion-segment-button
                class="diagnostic__tab"
                [value]="diagnosticTabs.avis"
                *ngIf="case.status === caseStatus.open"
            >
                <ion-label>Avis</ion-label>
            </ion-segment-button>
        </ion-segment>
    </div>

    <!-- Diagnosytics content -->
    <ng-container *ngSwitchCase="diagnosticTabs.diagnostic">
        <app-notification
            *ngFor="let notification of notifications"
            class="has-background-blue-pale mx-10 ion-margin-vertical px-6"
            [message]="notification"
            icon="warning"
            iconColor="warning"
            data-test-id="app-notification"
        >
        </app-notification>
        <!-- Diagnostic -->
        <app-diagnostic
            *ngFor="let diagnostic of case.diagnostics; trackBy: trackByFn"
            [item]="diagnostic"
        >
        </app-diagnostic>
        <!-- suggest diagnostic -->
        <ion-row
            class="ion-justify-content-center ion-align-items-center ion-margin-top"
        >
            <ion-col class="ion-padding size-17" size="auto">
                <ion-modal
                    #suggestmodal
                    [initialBreakpoint]="1"
                    [breakpoints]="[0,1]"
                    class="diagnostic__form"
                    [isOpen]="isOpen"
                    (ionModalWillDismiss)="openSuggestModal(false)"
                    [showBackdrop]="false"
                >
                    <ng-template>
                        <ion-header
                            class="has-background-white is-primary py-12 size-18 ion-text-left has-text-secondary weight-bold px-10"
                        >
                            {{ modalTitle }}
                        </ion-header>
                        <div class="height-160">
                            <app-input-text
                                [control]="submitForm"
                                name="description"
                                inputType="textarea"
                                [errorMessages]="[requiredMessage]"
                                [validators]="[requiredValidator]"
                                [rows]="6"
                                [hasBorder]="false"
                                class="size-11"
                            >
                            </app-input-text>
                        </div>

                        <ion-row
                            class="ion-justify-content-center ion-align-items-center mb-21"
                        >
                            <ion-col size="8">
                                <app-button
                                    [title]="buttonTitle"
                                    [disabled]="submitForm.get('description').invalid"
                                    [loading]="loading"
                                    shape="round"
                                    expand="full"
                                    fill="solid"
                                    color="primary"
                                    (click)="save()"
                                    (keyPress)="save()"
                                    class="ion-no-padding has-text-secondary"
                                    id="open-modal"
                                >
                                </app-button>
                            </ion-col>
                        </ion-row>
                    </ng-template>
                </ion-modal>
            </ion-col>
        </ion-row>
    </ng-container>

    <!-- Avis content -->
    <ng-container *ngSwitchCase="diagnosticTabs.avis">
        <ion-card
            *ngFor="let item of comments; trackBy: trackByFn"
            class="comment border-solid border-1 has-border-gray radius-18 mx-10 mt-23 px-10 py-12 size-12"
        >
            <ion-row>
                <ion-col size="auto">
                    <ion-icon
                        name="chatbubble-ellipses"
                        size="small"
                        color="dove-grey"
                    ></ion-icon>
                </ion-col>
                <ion-col>
                    <ion-text class="is-dark weight-600 has-text-primary">
                        Dr {{ item.agent.nom }} {{ item.agent.prenom }},
                        <span class="is-grey-black has-text-primary"
                            >{{ item.agent.fonction }}</span
                        >
                    </ion-text>
                    <div class="my-6">
                        <ion-text class="weight-200 has-text-secondary is-dark">
                            {{ item.content }}
                        </ion-text>
                    </div>
                    <div class="ion-text-right">
                        <ion-text
                            class="weight-300 has-text-primary is-primary"
                        >
                            Le {{ (item.createdAt | normalizeDate: '-') | date:
                            'd MMMM YYYY' | titlecase }}
                        </ion-text>
                    </div>
                </ion-col>
            </ion-row>
        </ion-card>
    </ng-container>
</ion-content>

<!-- Action button -->
<ion-footer
    *ngIf="showSuggestDiagnostic || isOpen || canStartDiagnostic"
    class="ion-no-border pb-12"
    [ngSwitch]="selectedTab"
>
    <ng-container *ngSwitchCase="diagnosticTabs.diagnostic">
        <!-- Diagnostics content -->
        <ion-row
            class="ion-justify-content-center ion-align-items-center ion-margin-top"
        >
            <ion-col class="is-white" size="10">
                <!-- Suggest diagnostic  -->
                <app-button
                    *ngIf="showSuggestDiagnostic"
                    data-test-id="button-close"
                    title="Proposer un diagnostic"
                    shape="round"
                    expand="full"
                    class="mb-10"
                    (click)="openSuggestModal(true)"
                    (keyPress)="openSuggestModal(true)"
                >
                </app-button>
                <!-- Start diagnostic automatically -->
                <app-button
                    *ngIf="canStartDiagnostic"
                    title="Lancer un auto diagnostic"
                    [loading]="loading"
                    (click)="getPrediction()"
                    (keyPress)="getPrediction()"
                    expand="full"
                    fill="clear"
                    class="flex is-primary radius-30 ion-justify-content-center border-1 border-solid"
                >
                </app-button>
            </ion-col>
        </ion-row>
    </ng-container>
    <ng-container *ngSwitchCase="diagnosticTabs.avis">
        <!-- Avis content -->
        <div class="comment__form ion-align-items-center px-5 pb-18">
            <input
                type="text"
                [(ngModel)]="comment"
                placeholder="Saisir un avis....."
                class="comment__form__input border-solid border-1 has-border-primary-light py-7 is-black size-13"
            />

            <ion-button
                (click)="saveComment()"
                (keyPress)="saveComment()"
                [disabled]="comment.trim() === ''"
                class="has-background-primary height-37 width-68"
            >
                <ion-icon
                    name="chatbubble-ellipses"
                    color="white"
                    size="large"
                ></ion-icon>
            </ion-button>
        </div>
    </ng-container>
</ion-footer>
